import { OnInit, QueryList, ChangeDetectorRef, AfterViewInit, EventEmitter, OnDestroy, OnChanges, SimpleChanges, ElementRef } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
import { MatChipList } from '@angular/material/chips';
import { CdkDragDrop, CdkDropList, CdkDrag } from '@angular/cdk/drag-drop';
import { BaseDirective } from '../../base.directive';
import { EuiChipComponent } from '../eui-chip/eui-chip.component';
import { EuiChipDragDrop } from './models/eui-chip-drag-drop.model';
import { EuiChip } from '../eui-chip/models/eui-chip.model';
import { EuiChipListDragService } from './services/eui-chip-list-drag.service';
import * as i0 from "@angular/core";
export declare class EuiChipListComponent extends BaseDirective implements OnInit, AfterViewInit, OnDestroy, OnChanges {
    private cd;
    private euiChipListDragService;
    private domSanitizer;
    chips: any[];
    toggleLinkMoreLabel: string;
    toggleLinkLessLabel: string;
    chipsSortOrder: ('ASC' | 'DESC');
    dragAndDropSourceName: string;
    dragAndDropConnectedTo: string[];
    ariaLabel: string;
    get isChipsRemovable(): boolean;
    set isChipsRemovable(value: boolean);
    _isChipsRemovable: boolean;
    get maxVisibleChipsCount(): any;
    set maxVisibleChipsCount(value: any);
    _maxVisibleChipsCount: any;
    get chipsLabelTruncateCount(): any;
    set chipsLabelTruncateCount(value: any);
    _chipsLabelTruncateCount: any;
    get isMaxVisibleChipsOpened(): boolean;
    set isMaxVisibleChipsOpened(value: boolean);
    _isMaxVisibleChipsOpened: boolean;
    get isChipsSorted(): boolean;
    set isChipsSorted(value: boolean);
    _isChipsSorted: boolean;
    get isChipsDragAndDrop(): boolean;
    set isChipsDragAndDrop(value: boolean);
    _isChipsDragAndDrop: boolean;
    chipsInit: EventEmitter<{
        chipList: MatChipList;
        chipsListDragAndDropItems: CdkDropList;
    }>;
    chipRemove: EventEmitter<{
        chips: EuiChip[];
        removed: EuiChip | {
            chip: EuiChip;
            event: Event;
        };
    }>;
    chipDragStarted: EventEmitter<EuiChipDragDrop>;
    chipDragReleased: EventEmitter<EuiChipDragDrop>;
    chipDropped: EventEmitter<EuiChipDragDrop>;
    chiplistFocus: EventEmitter<boolean>;
    get cssClasses(): string;
    droppableArea: CdkDragDrop<any[]>[];
    connectComponent: CdkDropList[];
    e2eAttr: string;
    euiChipsContent: QueryList<EuiChipComponent>;
    chipList: MatChipList;
    chipListDropList: CdkDropList;
    chipListDragAndDropItems: CdkDropList;
    euiChipItems: QueryList<ElementRef>;
    private destroy$;
    constructor(cd: ChangeDetectorRef, euiChipListDragService: EuiChipListDragService, domSanitizer: DomSanitizer);
    ngOnChanges(c: SimpleChanges): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    toggleTags(): void;
    getChipContent(euiChip: any): any;
    getChipLabel(euiChip: any): any;
    getChipIconBefore(euiChip: any): any;
    getChipIconAfter(euiChip: any): any;
    onRemove(removed: EuiChip | {
        chip: EuiChip;
        event: Event;
    }): void;
    trackByFn(index: number, euiChip: any): any;
    drop(e: CdkDragDrop<string[]>): void;
    onDragStarted(event: CdkDrag): void;
    onDragReleased(event: CdkDrag): void;
    onFocus(event: any): void;
    private generateId;
    private orderItems;
    static ɵfac: i0.ɵɵFactoryDef<EuiChipListComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<EuiChipListComponent, "eui-chip-list, div[euiChipList], ul[euiChipList]", never, { "chips": "chips"; "toggleLinkMoreLabel": "toggleLinkMoreLabel"; "toggleLinkLessLabel": "toggleLinkLessLabel"; "chipsSortOrder": "chipsSortOrder"; "dragAndDropSourceName": "dragAndDropSourceName"; "dragAndDropConnectedTo": "dragAndDropConnectedTo"; "ariaLabel": "ariaLabel"; "isChipsRemovable": "isChipsRemovable"; "maxVisibleChipsCount": "maxVisibleChipsCount"; "chipsLabelTruncateCount": "chipsLabelTruncateCount"; "isMaxVisibleChipsOpened": "isMaxVisibleChipsOpened"; "isChipsSorted": "isChipsSorted"; "isChipsDragAndDrop": "isChipsDragAndDrop"; }, { "chipsInit": "chipsInit"; "chipRemove": "chipRemove"; "chipDragStarted": "chipDragStarted"; "chipDragReleased": "chipDragReleased"; "chipDropped": "chipDropped"; "chiplistFocus": "chiplistFocus"; }, ["euiChipsContent"], ["euiChipListAppendContent"]>;
}
export declare class EuiChipListAppendContentDirective {
    static ɵfac: i0.ɵɵFactoryDef<EuiChipListAppendContentDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDefWithMeta<EuiChipListAppendContentDirective, "euiChipListAppendContent", never, {}, {}, never>;
}
